## Copyright (C) 2002 Red Hat, Inc.
## Copyright (C) 2002 Than Ngo <than@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

PROGNAME = 'redhat-switch-printer'
PROCDIR = '/usr/share/' + PROGNAME + '/'
TITLE = PROGNAME
COPYRIGHT = 'Copyright (C) 2002 Red Hat, Inc.'
AUTORS = ['Than Ngo <than@redhat.com>']
VERSION = '0.5.16'
GLADEPATH = ''
TRUE = (1==1)
FALSE = not TRUE

import re
import traceback
import sys
import os
import os.path
import shutil
import string

LPRNG = 0 
CUPS = 1
PRINTER = ['LPRng', 'cups']
PRINTER_PATH = '/etc/alternatives/print'

WARNING_TEXT = _('The Printing Systems LPRng/CUPS are not installed on system.\n'
                 'Please install them and restart this tool again.')

INFO_TEXT = _("This software is distributed under the GPL. Please Report bugs to Red Hat's Bug Tracking System: http://bugzilla.redhat.com/")

INFO_TEXT1 = _('Your Printing System has successfully been switched.\n')

TEXT = _('The redhat-switch-printer is a tool which enables users to easily switch between various Printing System (LPRng/CUPS) that they have installed.\n\nPlease choose your Printing System.')

def switch(i):
    os.system ('/sbin/chkconfig cups-lpd off 2>/dev/null >/dev/null')
    if i == LPRNG:
        os.system('/bin/rm /etc/printcap')
        os.system('/usr/sbin/alternatives --set print /usr/bin/lpr.LPRng')
        os.system('/sbin/service cups stop 2>/dev/null >/dev/null')
        os.system('/usr/sbin/printconf-backend --force-rebuild')
        os.system('/sbin/service lpd start 2>/dev/null >/dev/null')
    elif i == CUPS:
        os.system('/usr/sbin/alternatives --set print /usr/bin/lpr.cups')
        os.system('/sbin/service lpd stop 2>/dev/null >/dev/null')
        os.system('/usr/sbin/printconf-backend --force-rebuild')
        os.system('/sbin/service cups start 2>/dev/null >/dev/null')

def get_printer():
    printer_list = []
    for printer in PRINTER:
        if os.system('/bin/rpm -q ' + printer + '>/dev/null 2>&1') == 0:
            printer_list.append(printer)

    return(printer_list)

def get_default_printer(printer_list):
    if os.path.exists(PRINTER_PATH) and os.path.islink(PRINTER_PATH):
        default_printer = os.readlink(PRINTER_PATH)
        if default_printer == '/usr/bin/lpr.LPRng':
            return PRINTER[LPRNG]
        elif default_printer == '/usr/bin/lpr.cups':
            return PRINTER[CUPS]

    return printer_list[LPRNG]
